//
//  CSVDocument.swift
//  symbolicate
//
//  Created by Naruki Chigira on 2021/01/19.
//

import Foundation
import SwiftUI
import UniformTypeIdentifiers

/// CSV document to share.
struct CSVDocument: FileDocument {
    static var readableContentTypes: [UTType] {
        [.commaSeparatedText]
    }

    static var writableContentTypes: [UTType] {
        [.commaSeparatedText]
    }

    var content: String

    init(content: String) {
        self.content = content
    }

    init(configuration: ReadConfiguration) throws {
        guard let data = configuration.file.regularFileContents,
            let string = String(data: data, encoding: .utf8)
        else {
            throw CocoaError(.fileReadCorruptFile)
        }
        content = string
    }

    func fileWrapper(configuration: WriteConfiguration) throws -> FileWrapper {
        return FileWrapper(regularFileWithContents: content.data(using: .utf8)!)
    }
}
